// Message.cpp: implementation of the CMessage class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Message.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMessage::CMessage()
{
}
CMessage::~CMessage()
{
}

HWND CMessage::GetWindow(CWnd *pWnd)
{
	if ((!pWnd) || (!::IsWindow(pWnd->GetSafeHwnd())))  
		return ::GetDesktopWindow();
	return pWnd->GetSafeHwnd();
}
int CMessage::msgYesNo(LPCTSTR lpszText,LPCTSTR lpszTitle,CWnd *pWnd)
{
    int result = MessageBox( GetWindow(pWnd), lpszText , lpszTitle ,
               MB_YESNO|MB_ICONEXCLAMATION|MB_DEFBUTTON2);

	if (result==IDYES) {
		LPCTSTR  lpszConfirm = _T("Are you sure ?");
		int result = MessageBox( GetWindow(pWnd), 
				lpszConfirm , lpszTitle ,
				MB_YESNO|MB_ICONSTOP|MB_DEFBUTTON2);
	}
	return ((result==IDYES) ? (1) : (0));
}

void CMessage::msg(LPCTSTR lpszText,LPCTSTR lpszTitle,CWnd *pWnd)
{
	::MessageBox( GetWindow(pWnd), lpszText , lpszTitle , MB_OK);
}

void CMessage::Error(LPCTSTR lpszText,LPCTSTR lpszTitle)
{
	::MessageBox( GetWindow(), lpszText ,
			lpszTitle , MB_OK|MB_ICONEXCLAMATION);
}

void CMessage::Error(DWORD errCode, CWnd *pWnd)//system error message
{
	LPVOID lpMsgBuf;
	FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS ,
		NULL,  errCode, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL );

	::MessageBox( GetWindow(pWnd), (LPCTSTR)lpMsgBuf, "Error", MB_OK | MB_ICONINFORMATION );
	::LocalFree(lpMsgBuf);
}




