// MyToolTip.cpp : implementation file
//

#include "stdafx.h"
#include "MyToolTip.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyToolTip

CMyToolTip::CMyToolTip()
{
}
CMyToolTip::~CMyToolTip()
{
}

BEGIN_MESSAGE_MAP(CMyToolTip, CToolTipCtrl)
	//{{AFX_MSG_MAP(CMyToolTip)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyToolTip message handlers
BOOL CMyToolTip::Create(CWnd *pParentWnd,DWORD dwInitial,DWORD dwAutoPop, BOOL bActivate)
{
	if (!CToolTipCtrl::Create(pParentWnd,WS_CHILD|WS_POPUP|WS_VISIBLE))
		return FALSE;
  
	SendMessage(TTM_SETMAXTIPWIDTH, 0, SHRT_MAX);
    SendMessage(TTM_SETDELAYTIME, TTDT_AUTOPOP, dwAutoPop); // SHRT_MAX);
    SendMessage(TTM_SETDELAYTIME, TTDT_INITIAL, dwInitial);
    SendMessage(TTM_SETDELAYTIME, TTDT_RESHOW, 200);

	Activate(bActivate);
    return TRUE;
}
BOOL CMyToolTip::AddToolTip(CWnd *pWnd,UINT uToolID)
{
	if (!uToolID)  return FALSE;
	CString strTip;
	if (strTip.LoadString(uToolID))
		return AddToolTip( pWnd, (LPCTSTR)strTip );
	return FALSE;
}
BOOL CMyToolTip::AddToolTip(CWnd *pWnd, LPCTSTR lpszTip)
{
    if (!pWnd)  return FALSE;

	RECT rc;
	pWnd->GetWindowRect(&rc);

	TOOLINFO  ti;
	ti.cbSize = sizeof(TOOLINFO); 
    ti.uFlags = TTF_SUBCLASS | TTF_IDISHWND;
	ti.uId = (UINT) pWnd->GetSafeHwnd();
	::CopyRect(&ti.rect,&rc);
	ti.hwnd = pWnd->GetParent()->GetSafeHwnd();
	ti.hinst = AfxGetInstanceHandle();
	ti.lpszText=(LPTSTR) lpszTip;

	return (int) SendMessage(TTM_ADDTOOL,0,(LPARAM)&ti);
}
//calls this function from the first line of parent's WindowProc
void CMyToolTip::RelayMessage(UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_LBUTTONDOWN:
	case WM_RBUTTONDOWN:
	case WM_MBUTTONDOWN:
	case WM_LBUTTONUP:
	case WM_MBUTTONUP:
	case WM_RBUTTONUP:
	case WM_MOUSEMOVE:
		{
			MSG m;
			m.hwnd = m_hWnd;
			m.message = message;
			m.wParam = wParam;
			m.lParam = lParam;
			RelayEvent(&m);
		}
	}
}


