// ShellExecuter.cpp: implementation of the CShellExecuter class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"
#include "ShellExecuter.h"
#include "Registry.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CShellExecuter::CShellExecuter()
{
}
CShellExecuter::~CShellExecuter()
{
}
BOOL CShellExecuter::Run(LPCTSTR lpszCommand)
{
    if (!lpszCommand)  return FALSE;
	CString sCommand = lpszCommand;

	// Parse out the Command
	int nCmdLen = sCommand.Find(__TEXT(' '));
	if (nCmdLen == -1) {
		nCmdLen = sCommand.GetLength();
	}

	// Parse out the parameters to pass to the Command
	CString sParams = sCommand.Mid(nCmdLen);
	sParams.TrimLeft();  // Remove extra white space

	// Have the Shell run our command with its parameters
	HINSTANCE hinst = ::ShellExecute(::GetDesktopWindow(), NULL, 
		sCommand.Left(nCmdLen), sParams, NULL, SW_SHOWNORMAL);

	if (hinst < (HINSTANCE) HINSTANCE_ERROR) {
      // If the command failed to run, tell the user.
		::MessageBox(::GetDesktopWindow(),_T("Command failed to execute"), 
         _T("Error"), MB_ICONSTOP | MB_OK);
		return FALSE;
	}
	return TRUE;
}
BOOL CShellExecuter::Navigate(CString strShellPath,BOOL bShowError)
{
	if (!strShellPath.IsEmpty())
		return Exec(_T("Open"), strShellPath ,NULL ,bShowError);
	return FALSE;
}
BOOL CShellExecuter::Command(CString strShellPath,BOOL bShowError)
{

	return TRUE;
}

BOOL CShellExecuter::CreateFileCommand(CString strShellCommand,CString strExtension,BOOL bShowError)
{
	CRegistry reg;
	CString strCommand = strShellCommand;
	CString	extension = strExtension;

	reg.Trim(&strCommand,_T(' '));
	reg.Trim(&strCommand);
	reg.Trim(&strCommand,_T(' '));
	if (strCommand.IsEmpty())  return FALSE; //no command

	if (!extension.CompareNoCase(_T(".lnk"))) //create link
	{
		CString tmp;
		int iFind = strCommand.ReverseFind(_T('%'));
		if (iFind>=0)
		{
			strCommand = strCommand.Left(iFind);
			strCommand += _T("C:\\");
		}
	}

	int nCmdLen = strCommand.Find(_T(' '));
	if (nCmdLen == -1) {
		nCmdLen = strCommand.GetLength();
	}
	CString strParams = strCommand.Mid(nCmdLen);
	reg.Trim(&strParams,_T(' '));
	strCommand = strCommand.Left(nCmdLen);

	return Exec(_T("Open"), strCommand , strParams,bShowError);
}

BOOL CShellExecuter::Print(CString strShellPath,BOOL bShowError)
{
	if (!strShellPath.IsEmpty()) {
		///we need to check if this is a document or not
		
		
		return Exec(_T("print"),strShellPath,NULL,bShowError);
	}
	return FALSE;
}

BOOL CShellExecuter::Exec(LPCTSTR lpszVerb,LPCTSTR lpszCommand,LPCTSTR lpszParams,BOOL bShowError)
{
	HINSTANCE hinst = ::ShellExecute(AfxGetMainWnd()->m_hWnd ,
		lpszVerb ,lpszCommand , lpszParams , NULL,SW_SHOWDEFAULT );
	if (bShowError)
		Error((UINT)hinst);
	return ((UINT)hinst>32);
}
void CShellExecuter::Error( UINT hHinstanceCode)
{
    // If the command failed to run, tell the user.
    if (hHinstanceCode < HINSTANCE_ERROR) {
		::MessageBox(::GetDesktopWindow(), _T("Command failed to execute"), 
         _T("Networker Application") , MB_ICONSTOP | MB_OK);
    }
}









